<script>
  import { onMount } from 'svelte';
  import { KeycloakInterface, KeycloakStore } from '@auth/keycloak';

  let keycloak = new KeycloakInterface();

  KeycloakStore.subscribe((value) => {
    keycloak = value.keycloak;
  });

  const loginPageInit = async () => {
    // Get the referring page from the search params, otherwise redirect to homepage
    const searchParams = new URLSearchParams(window.location.search);
    const referer = searchParams.get('referer' || '/');
    if (keycloak.authenticated) {
      // Sanitize the referer from external domains
      // Relative URLs will take on the origin of this login page
      // Absolute URLs will be unmodified
      let referer_url;
      if (referer !== null) {
        referer_url = new URL(referer, window.location.origin);
      } else {
        referer_url = new URL('/', window.location.origin);
      }
      if (window.location.origin === referer_url.origin) {
        // We returned here after authentication, redirect back to the referring page
        window.location.replace(referer_url);
      } else {
        // We should throw a fit about a bad URL here or just ignore it?
        window.location.replace('/');
      }
    } else {
      // Do keycloak login. Navigate back to this page, because the keycloak cookie will not be set yet.
      // This page needs to load first, load the keycloak JWT, set the JWT into a cookie, then load the referring page
      await keycloak.login(window.location.href);
    }
  };
  onMount(() => {
    loginPageInit();
  });
</script>

<svelte:head>
  <title>Login</title>
</svelte:head>
<div class="row">This page will redirect you shortly...</div>
